



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>javascript中的链表结构—从链表中删除元素</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">javascript中的链表结构—从链表中删除元素</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 01:02:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>1.概念</strong></p>
<p>　　上一个博文我们讲到链表，其中有一个方法remove()是暂时注释的，这个方法有点复杂，需要添加一个Previous()方法找到要删除的元素的前一个节点，这一个博文我们来分析一下这个remove()方法。</p>
<p>　　从链表中删除节点的时候，需要先找到这个待删除节点的前面的节点。找到这个节点之后修改它的next属性，使其指向待删除节点的下一个节点，这样就把待删除节点给删除了，是不是很简单呢？但是问题来了，我们是不是要找到待删除节点的前面一个节点呢？这样就需要添加一个findPrevious()方法来做这件事情。</p>
<p>　　findPrevious()方法遍历链表中的元素，检查每一个节点的下一个节点是否存储着待删除数据。如果找到，返回该节点（即前面的节点），这样就可以修改它的next属性了。findPrevious()方法定义如下：</p>
<div>
<pre class="prettyprint linenums">function findPrevious(item){<br />
    var currNode =     this.head;<br />
    while ( (currNode.next != null) &amp;&amp; (currNode.next.element != item) ){<br />
        currNode = currNode.next;<br />
    }<br />
    return currNode;<br />
}</pre>
</div>
<p>　　有了这个findPrevious()方法之后就可以考虑如何写这个remove()方法了。代码如下：</p>
<div>
<pre class="prettyprint linenums">function remove(item){<br />
    var preNode = this.findPrevious(item);<br />
    if(preNode.next != null){<br />
        preNode.next = preNode.next.next;<br />
    }<br />
}</pre>
</div>
<p>该方法中有一句preNode.next = preNode.next.next;这个使用了javascript中的对象属性，看起来有点奇怪，但是完全能说得通。</p>
<p><strong>2.代码实现</strong></p>
<p>下面的是完整的代码和测试代码：</p>
<div>
<pre class="prettyprint linenums">function Node(element) {<br />
    this.element = element;<br />
    this.next = null;<br />
}

function LList() {<br />
    this.head = new Node('head');<br />
    this.find = find;<br />
    this.insert = insert;<br />
    this.findPrevious = findPrevious;<br />
    this.remove = remove;<br />
    this.display = display;<br />
}

function find(item) {<br />
    var currNode = this.head;<br />
    while(currNode.element != item) {<br />
        currNode = currNode.next;<br />
    }<br />
    return currNode;<br />
}

//插入一个元素<br />
function insert(newElement, item) {<br />
    var newNode = new Node(newElement);<br />
    var current = this.find(item);<br />
    newNode.next = current.next;<br />
    current.next = newNode;<br />
}

function findPrevious(item){<br />
    var currNode =     this.head;<br />
    while ( (currNode.next != null) &amp;&amp; (currNode.next.element != item) ){<br />
        currNode = currNode.next;<br />
    }<br />
    return currNode;<br />
}

function remove(item){<br />
    var preNode = this.findPrevious(item);<br />
    if(preNode.next != null){<br />
        preNode.next = preNode.next.next;<br />
    }<br />
}

function display() {<br />
    var currNode = this.head;<br />
    while(!(currNode.next == null)) {<br />
        document.write(currNode.next.element + '&amp;nbsp;');<br />
        currNode = currNode.next;<br />
    }<br />
}

//测试程序<br />
var cities = new LList();<br />
cities.insert("Conway", "head");<br />
cities.insert("Russellville", "Conway");<br />
cities.insert("Carlise", "Russellville");<br />
cities.insert("Alma", "Carlise");<br />
cities.display();<br />
document.write('&lt;br&gt;');<br />
cities.remove('Carlise');<br />
cities.display();</pre>
</div>
<p>最后的输出结果如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/72678/201609/72678-20160919233248324-2048218802.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k25m58.html">webservice wsdl axis2报错 Provider com&period;bea&period;xml&period;stream&period;MXParserFactory not found</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql715x9.html">oracle主键自增</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zmd269.html">MySQL与SQL比较有那些区别呢</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1nll59.html">完成端口iocp&mdash;&mdash;在螺丝壳里做道场</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1276x8.html">C&plus;&plus;学习笔记之由文本文件读取数据到vector模板建立的二维数组 并存储为新的文本文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnp50oq.html">Populating Next Right Pointers in Each Node II</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydo7ydq.html">aspx页面状态管理Cookie和ViewState</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k14g5j9.html">KVC 和KVO浅谈</a>
		</li>
						<li><a href="https://www.batexi.com/a/950rrn68.html">hdoj 3478 Catch&lpar;二分图判定&plus;并查集&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ypkp08.html">Oracle SQL自带函数整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j35gv8.html">关于jquery全选反选 批量删除的一点心得</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zozyl3q.html">stm&period;go</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ymejn8.html">格式化数据保留两位小数，输入格式为 ：xxx&comma;xx&comma;&comma;&comma;&comma;x&comma;&comma;&lpar;x为浮点数&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyydj1xq.html">北京U3D外包团队 UE4红军抗战案例 Unity3D红军抗战案例 UE4下载和安装虚幻4游戏引擎</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwpkg79.html">Java IO、NIO、AIO知识总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw34378.html">PEP 492 -- Coroutines with async and await syntax 翻译</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jdx43q.html">Mac cnpm安装失败及解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2544xwq.html">gogs wekan 集成试用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjwdyjq.html">《Java设计模式》之模板方法模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ppooeq.html">Dubbo&plus;Zookeeper&plus;Spring整合应用篇-Dubbo基于Zookeeper实现分布式服务（转）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/2q70pk18.html">android ndk开发（二）实现一个官方demo</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1dml4q.html">Fragment中的按键监听</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kd0yr9.html">Android 使用xml序列化器生成xml文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gxee7q.html">HTML5 初步了解</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdxwn08.html">json数组的序列化和反序列化json数组的序列化和反序列化</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1dvd4q.html">ARC下的所有权修饰符</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx42jz9.html">equals&lpar;&rpar;和hashCode&lpar;&rpar;之间的关系</a>
			</li>
						<li><a href="https://www.batexi.com/a/m964mw48.html">C&num;语言&mdash;&mdash;类</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8ex5mzq.html">Linux运维常用命令总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyo47d8.html">0006 《SQL必知必会》笔记02-计算字段与函数</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
